<?PHP

/* ====================
Seditio - Website engine
Copyright Neocrome
http://www.neocrome.net
[BEGIN_SED]
File=plugins/emailchange/emailchange.php
Version=101
Updated=
Type=Plugin
Author=GoCoding.Com
Description=Standalone Email Changer Module
[END_SED]

[BEGIN_SED_EXTPLUGIN]
Code=emailchange
Part=main
File=emailchange
Hooks=standalone
Tags=
Order=10
[END_SED_EXTPLUGIN]
==================== */

if (!defined('SED_CODE') || !defined('SED_PLUG')) { die('Wrong URL.'); }

$s = sed_import('s','G','STX');
$m = sed_import('m','G','STX');

$v = sed_import('v','G','ALP');

$em1 = sed_import('em1','P','STX',64, TRUE);
$em2 = sed_import('em2','P','STX',64, TRUE);
$pw = sed_import('pw','P','PSW',16, TRUE);
$err = "";
$pw = str_replace("'","",$pw);
$em1=strtolower($em1);
$em1=str_replace("'","",$em1);
$em2=strtolower($em2);
$em2=str_replace("'","",$em2);

$plugin_title = "Change Your Email Address";
$plugin_subtitle = "";
$plugin_body = "";

function checkemail($em) {
	if (empty($em)  || $em=="") return "No Email Address Specified";
	if (!ereg("^.+@.+\..+",$em)) return "Invalid Email Address";
	return "";
}

function emailduplicate($em) {
	global $usr, $db_users;
	$q = sed_sql_query("SELECT * FROM $db_users WHERE user_email LIKE '$em'");
	if (!$q) return "";
	$num = sed_sql_numrows($q);
	if ($num == 0) return "";
	$row = sed_sql_fetcharray($q);
	if (!$row) return "Database Error!";
	if ($row['user_id'] == $usr['id']) {
		return "This is your current email address!";
	}
	return "This email address is already being used!";
}

function checkpw($pw) {
	global $usr, $db_users;
	$pwmd5 = md5($pw);
	$uid = floor($usr['id']);
	$q = sed_sql_query("SELECT * FROM $db_users WHERE user_id='$uid' AND user_password LIKE '$pwmd5'");
	if ($q) {
		if (sed_sql_numrows($q)==1) {
			return "";
		}
	}
	return "Incorrect Password!";
}

function dochange($em) {
	//make the changes and save the users maingrp id in user_sid
	global $usr, $db_users, $db_groups_users, $cfg, $L;
	$uid = floor($usr['id']);
	$vkey = md5(microtime());
	$q = sed_sql_query("UPDATE $db_users SET user_email = '$em', user_lostpass = '$vkey', user_sid = user_maingrp, user_maingrp='2' WHERE user_id='$uid';");
	$q = sed_sql_query("INSERT INTO $db_groups_users VALUES('$uid','2','0','','');");
	
	//now send the mail
	$rsubject = $cfg['maintitle']." - Email Address Change";
	$ractivate = $cfg['mainurl']."/plug.php?e=emailchange&m=validate&v=".$vkey;
	$rbody = sprintf("Hi %s,\n\nYour Email Address Has Now Been Updated.\n\nPlease Click The Following Link To Re-Activate You Account :\n\n%s\n", $usr['name'], $ractivate);
	$rbody .= "\n\n".$L['aut_contactadmin'];
	sed_mail ($em, $rsubject, $rbody);

	return "";	
}


function dovalidate($v) {
	global $db_users, $db_groups_users;
	//validate the account
	// & restores users maingrp id from user_sid
	$sql = sed_sql_query("SELECT user_id FROM $db_users WHERE user_lostpass='$v' AND user_maingrp=2");

	if ($row = sed_sql_fetcharray($sql))
		{
		$sql = sed_sql_query("UPDATE $db_users SET user_maingrp=user_sid WHERE user_id='".$row['user_id']."' AND user_lostpass='$v'");
		$sql = sed_sql_query("DELETE FROM $db_groups_users WHERE gru_groupid=2 AND gru_userid='".$row['user_id']."'");
		sed_auth_clear($row['user_id']);
		sed_redirect("message.php?msg=106");
		exit;
		}
	else
		{
		sed_shield_update(7, "Account validation");
		sed_log("Wrong validation URL", 'sec');
		sed_redirect("message.php?msg=157");
		exit;
		}	
}

if ($m=="change") 
	{
		if ($usr['auth']['plug']['emailchange'] < 2) {
			die("Access Denied!");
		}
		
		//check email
		if ($em1 == $em2) {
			$err = checkemail($em1);
			if ($err=="") {
				$err=emailduplicate($em1);
				if ($err=="") {
					//now check password
					$err = checkpw($pw);
					if ($err=="") {
						//make the change
						$err=dochange($em1);
						if ($err=="") {
							header("location: plug.php?e=emailchange&m=done");
							exit;
						}
					}
				}
			}
		} else {
			$err = "Emails Don't Match";
		}
	}
elseif ($m=="done")
	{
		//notify success
		$plugin_body .= "<div align='center' style='color: #0000ff; text-align: center; font-weight: bold; font-size: 120%;'>";
		$plugin_body .= "Your Email Address Has Been Successfully Updated.<br />";
		$plugin_body .= "A Confirmation Email Has Been Sent To That Address.<br />";
		$plugin_body .= "Please Check Your Mail and Click On The Link In It To Complete The Process.<br />";
		$plugin_body .= "Your Account Will Remain Incative Until This Has Been Done.";
		$plugin_body .= "</div>";
		return;
	}
elseif ($m=="validate" && strlen($v) == 32)
	{
		dovalidate($v);
		return;
	}

	//check its a valid user
	if ($usr['auth']['plug']['emailchange'] < 2) {
		die("Access Denied!");
	}
	
	
	//display form and info
	if ($err != "") {
		$err = "<div align='center' style='color: #ff0000; text-align: center; font-weight: bold;'>" . $err . "</div>";
	}
	$plugin_subtitle = "Fill in and submit the form below to change your registered email address.";
	$plugin_body .= "$err<form method='POST' action='plug.php?e=emailchange&m=change'>";
	$plugin_body .= "<center><table class='cells' style='width: 450px;'>";
	$plugin_body .= "<tr><td colspan='2' align='center'><b>Once you have submitted this form your account will be set as inactive until your email address has been verified.<br />&nbsp;<br />PLEASE ENSURE THE EMAIL ADDRESS IS VALID AND BELONGS TO YOU!</b></td></tr>";
	$plugin_body .= "<tr><td align='right' width='200'>New Email Address: </td><td align='left'><input type='text' name='em1' value='$em1' /></td></tr>";
	$plugin_body .= "<tr><td align='right'>Confirm Email Address: </td><td align='left'><input type='text' name='em2' value='$em2' /></td></tr>";
	$plugin_body .= "<tr><td align='right'>Enter Current Password: </td><td align='left'><input type='password' name='pw' /></td></tr>";
	$plugin_body .= "<tr><td>&nbsp;</td><td align='left'><input type='submit' name='submit' value='Submit' /></td></tr>";
	$plugin_body .= "</table></center></form>";


$plugin_body .= "";

?>
